#!/usr/bin/python
# -*- coding: utf-8 -*-

from Imports import *
import urllib2
import httplib
import urlparse
#################
import urllib,urllib2,re,sys,socket,time

language = "1"

if language=="0":
  language="de"
elif language=="1":
  language="fr"

numbers=["10","25","50","100",]
videosPerPage = 20
def cleanTitle(title):
        title=title.replace("&lt;","<").replace("&gt;",">").replace("&amp;","&").replace("&#39;","'").replace("&#039;","'").replace("&quot;","\"").replace("&szlig;","ß").replace("&ndash;","-")
        title=title.replace("&Auml;","Ä").replace("&Uuml;","Ü").replace("&Ouml;","Ö").replace("&auml;","ä").replace("&uuml;","ü").replace("&ouml;","ö")
        title=title.strip()
        return title

def listShows(url):
        if url=="ALL_VIDS":
          if language=="de":
            url="http://videos.arte.tv/de/videos/alleVideos"
          elif language=="fr":
            url="http://videos.arte.tv/fr/videos/toutesLesVideos"
        elif url=="SHOWS_AZ":
          if language=="de":
            url="http://videos.arte.tv/de/videos/sendungen"
          elif language=="fr":
            url="http://videos.arte.tv/fr/videos/programmes"
        elif url=="EVENTS":
          url="http://videos.arte.tv/"+language+"/videos/events/index-3188672.html"
        content = getUrl(url)
        content = content[content.find('<div class="navTop"></div>'):]
        content = content[:content.find('</ul>')]
        spl=content.split('<a href')
        urls = []
        titles = []
        for i in range(1,len(spl),1):
          entry=spl[i]
          match=re.compile('>(.+?)<', re.DOTALL).findall(entry)
          title=cleanTitle(match[0])
          match=re.compile('="(.+?)"', re.DOTALL).findall(entry)
          url="http://videos.arte.tv"+match[0]
          urls.append(str(url))
          titles.append(str(title))
        return titles, urls  
          


def listVideos(url):
        urlMain=url
        content = getUrl(url)
        spl=content.split('<div class="video">')
        urls = []
        titles = []
        for i in range(1,len(spl),1):
          entry=spl[i]
          match=re.compile('<p>(.+?)</p>', re.DOTALL).findall(entry)
          date=match[0]
          match=re.compile('<p class="teaserText">(.+?)</p>', re.DOTALL).findall(entry)
          desc=cleanTitle(match[0])
          desc=date+"\n"+desc
          match=re.compile('<h2><a href="(.+?)">(.+?)</a></h2>', re.DOTALL).findall(entry)
          url="http://videos.arte.tv"+match[0][0]
          title=cleanTitle(match[0][1])
          entry=entry[entry.find('class="thumbnail"'):]
          match=re.compile('src="(.+?)"', re.DOTALL).findall(entry)
          thumb="http://videos.arte.tv"+match[0]
          
          print "url 1=", url
          titles.append(str(title))
          urls.append(str(url))

        return titles, urls


def playVideo(url):
        url=url.replace("/videos/","/do_delegate/videos/").replace(".html",",view,asPlayerXml.xml")
        content = getUrl(url)
        match=re.compile('<video lang="'+language+'" ref="(.+?)"', re.DOTALL).findall(content)
        url=match[0]
        content = getUrl(url)
        match1=re.compile('<url quality="hd">(.+?)</url>', re.DOTALL).findall(content)
        match2=re.compile('<url quality="sd">(.+?)</url>', re.DOTALL).findall(content)
        urlNew=""
        if len(match1)==1:
          urlNew=match1[0]
        elif len(match2)==1:
          urlNew=match2[0]
          
        path= '"' + urlNew.replace("/MP4:","/mp4:") + '"' + ' --start=0 --swfVfy=1 --swfUrl="http://videos.arte.tv/blob/web/i18n/view/player_23-3188338-data-5044926.swf"'  
        print "path =", path
        return path
#        listitem = xbmcgui.ListItem(path=urlNew.replace("/MP4:","/mp4:")+" swfVfy=1 swfUrl=http://videos.arte.tv/blob/web/i18n/view/player_23-3188338-data-5044926.swf")
#        return xbmcplugin.setResolvedUrl(pluginhandle, True, listitem)


def getUrl(url,cookie=None):
        req = urllib2.Request(url)
        req.add_header('User-Agent', 'Mozilla/5.0 (Windows NT 6.1; rv:16.0) Gecko/20100101 Firefox/16.0')
        if cookie!=None:
          req.add_header('Cookie',cookie)
        response = urllib2.urlopen(req)
        link=response.read()
        response.close()
        return link

def parameters_string_to_dict(parameters):
        ''' Convert parameters encoded in a URL to a dict. '''
        paramDict = {}
        if parameters:
            paramPairs = parameters[1:].split("&")
            for paramsPair in paramPairs:
                paramSplits = paramsPair.split('=')
                if (len(paramSplits)) == 2:
                    paramDict[paramSplits[0]] = paramSplits[1]
        return paramDict


#################
class Arte(Screen):
    def __init__(self, session):
		
		Screen.__init__(self, session)
                self.skin = SkinList2.skin
		title = "Arte"
		self["title"] = Button(title)

        	self["list"] = MenuList([])
		self["info"] = Label()
		self["KEY_HELP"] = Button(_("HELP"))
                self["actions"] = ActionMap(["OkCancelActions",], {"ok": self.okClicked, "cancel": self.cancel, }, -1)
                self.srefOld = self.session.nav.getCurrentlyPlayingServiceReference()
		global SREF
                SREF = self.srefOld
                self.ict = 0
                self.names = []       
                self.urls = []  
                self.onLayoutFinish.append(self.startSession)

    def cancel(self):
                self.session.nav.playService(SREF)
                self.close()

    def startSession(self):
                self.names, self.urls = listShows("SHOWS_AZ")
                print "self.urls = ", self.urls

#                 url = shows[0]
#                 videos = []
#                 videos = listVideos(url)
#                 print "videos = ", videos

#                 url = "http://videos.arte.tv/fr/videos/le-centre-medical-et-social-d-ellinikon--7078112.html"
#                 playVideo(url)

                self["info"].setText("")
                self["list"].setList(self.names)

    
    def okClicked(self):
          itype = self["list"].getSelectionIndex()
          #print "itype = ", itype
          if itype is not None: 
                url = self.urls[itype]
                #print "Myvideo url =", url
                self.session.open(Getvideos, url)
                

############ 
class Getvideos(Screen):
    def __init__(self, session, url):
		
		Screen.__init__(self, session)
                self.skin = SkinList2.skin
		title = "MyVideo.de"
		self["title"] = Button(title)

        	self["list"] = MenuList([])
		self["info"] = Label()
		self["KEY_HELP"] = Button(_("HELP"))
                self["actions"] = ActionMap(["OkCancelActions",], {"ok": self.okClicked, "cancel": self.cancel, }, -1)
                self.srefOld = self.session.nav.getCurrentlyPlayingServiceReference()
		global SREF
                SREF = self.srefOld
                self.ict = 0
                self.url = url
                self.names = []       
                self.urls = []  
                self.onLayoutFinish.append(self.startSession)

    def cancel(self):
                self.session.nav.playService(SREF)
                self.close()

    def startSession(self):
                self.names, self.urls = listVideos(self.url)
                print "self.names = ", self.names
                print "self.urls = ", self.urls

                self["info"].setText("")
                self["list"].setList(self.names)

    
    def okClicked(self):
          itype = self["list"].getSelectionIndex()
          #print "itype = ", itype
          if itype is not None: 
                vid = self.names[itype]
                url = self.urls[itype]
                vidurl = playVideo(url)
                print "vidurl = ", vidurl
#                self.session.open(Vidurl, name, url)
                desc = " "
                self.session.open(Showrtmp, vid, vidurl, desc)


class Showrtmp(Screen):

    def __init__(self, session, name, url, desc):
		Screen.__init__(self, session)
#                self.skin = SkinA.skin
                self.skin = SkinC.skin
                title = "Play"
                self.setTitle(title)

        	self["list"] = MenuList([])
		self["info"] = Label()
                self["key_red"] = Button(_("Exit"))
		self["key_green"] = Button(_("Download"))
		self["key_yellow"] = Button(_("Play"))
		self["key_blue"] = Button(_("Stop Download"))
                self["setupActions"] = ActionMap(["SetupActions", "ColorActions", "TimerEditActions"],
		{
			"red": self.close,
			"green": self.okClicked,
			"yellow": self.play,
			"blue": self.stopdl,
			"cancel": self.cancel,
			"ok": self.okClicked,
		}, -2)
                self.icount = 0
#                self.ict = 0
                #print "Showrtmp : name =", name
                self.name = name
                self.url = url
#                self["info"].setText("Must do (1) Download  (2) Play. \n\nVideo selected :-  " + self.name)
                txt = "Must do (1) Download  (2) Play.\n\n" + self.name + "\n\n" + desc
                self["info"].setText(txt)

                self.srefOld = self.session.nav.getCurrentlyPlayingServiceReference()
                self.onLayoutFinish.append(self.getrtmp)

    def getrtmp(self):
#            try:           
                       #print "Showtrmp self.url =", self.url
                       fold = config.plugins.webmedia.cachefold.value
                       fname = self.name.replace(" ", "-")
                       fname = fname.replace("/", "-")
                       svfile = fold + "/Video1.mp4"
                       self.svf = svfile
                       cmd = "rm " + svfile
                       os.system(cmd)
                       self.urtmp = "rtmpdump -r " + self.url + " -o '" + svfile + "'"
                       print "self.urtmp = ", self.urtmp         


#            except:
#                    self.close()
                    

    def okClicked(self):
                self["info"].setText("Downloading ....")
                svfile = self.svf


#                cmd = "rtmpdump -r " + "'" + self.url + "'" + " -n " + "'" + self.urln + "'" + " -y " + "'" + self.urly + "'" + " -a " + "'" + self.urla + "'" + " -o " + "'" + svfile + "' &"
#                #print "cmd = ", cmd 
                cmd = "rm " + svfile
                os.system(cmd)
                #print "Going Into JobManager"
                JobManager.AddJob(downloadJob(self, self.urtmp, svfile, 'Title 1')) 
                
                self.LastJobView()

 
    def LastJobView(self):
		currentjob = None
		for job in JobManager.getPendingJobs():
			currentjob = job

		if currentjob is not None:
			self.session.open(JobView, currentjob)
 
    def play(self):
          if os.path.exists(self.svf):
                #print "Showrtmp here 2"
                svfile = self.svf
                print "svfile play= ", svfile
                pvd = Playvid(self.session, self.name, svfile)
                pvd.openTest()
         
          else:      
                txt = "Download Video first."
                self["info"].setText(txt)
                
    
    def cancel(self):
#	        self.session.nav.playService(self.srefOld)
                self.session.nav.playService(SREF)                
                self.close()

    def stopdl(self):
                svfile = self.svf
                cmd = "rm " + svfile
                os.system(cmd)                
                self.session.nav.playService(self.srefOld)
                cmd1 = "killall -9 rtmpdump"
                cmd2 = "killall -9 wget"
                os.system(cmd1)
                os.system(cmd2)
                self.close()

 
    def keyLeft(self):
		self["text"].left()
	
    def keyRight(self):
		self["text"].right()

    def keyNumberGlobal(self, number):
		#print "pressed", number
		self["text"].number(number)
		
#################################################

def main(session, **kwargs):
	session.open(Arte)

def Plugins(**kwargs):
	return [
		PluginDescriptor(name = "Arte", description = _("Arte Videos"), where = PluginDescriptor.WHERE_PLUGINMENU, fnc = main),
		PluginDescriptor(name = "Arte", description = _("Arte videos"), where = PluginDescriptor.WHERE_EXTENSIONSMENU, fnc=main)]






























